unit CurrentTrackInfoToFile_Defines;

interface

uses
  Windows,
  Menus,
  ComCtrls,
  Classes,
  {
  gnugettext,
  Locales,
  }
  AIMPSDKAddons,
  AIMPAddonCustomPlugin;

type
  TSettings = record
   Filename: WideString;
   Template: WideString;
   Count: Integer;
   Bottom: Boolean;
   UTF: Boolean;
  end;

  TObjProc = procedure of object;

  TEntries = record
   Playlist: HPLS;
   EntryIndex: Integer;
  end;

const
  //plugin data
  myPluginName = 'Current Track info to file';
  myPluginAuthor = 'Korney San';
  myPluginInfo = 'Puts current track info to text file.';

  //settings
  optFilename = 'Filename';
  optTemplate = 'Template';
  optLanguage = 'Language';
  optCount = 'Count';
  optBottom = 'Bottom';
  optUTF = 'UTF';

  CountMax = 1000;

  //default filename
  sFileName = 'CurrentTrackInfo.txt';

var
  StaticWideString: array [0..MAX_PATH-1] of WideChar;
  AIMPProfilePath: WideString = '';
  PluginsFolder: WideString = '';
  myPluginFolder: WideString = '';
  //myLocales: TLocales = nil;
  mySettings: TSettings = (Filename: ''; Template: '%R - %T'; Count: 1; Bottom: False; UTF: False);
  OnSettingsChange: TObjProc = nil;

procedure LoadSettings(const Plugin: TAIMPAddonsCustomPlugin; const Section: String; var Settings: TSettings);
procedure SaveSettings(const Plugin: TAIMPAddonsCustomPlugin; const Section: String; const Settings: TSettings);
procedure SettingsChanged(const Settings: TSettings);

implementation

uses
  ShlObj,
  SysUtils;

procedure LoadSettings(const Plugin: TAIMPAddonsCustomPlugin; const Section: String; var Settings: TSettings);
 var
  Path: array [0..2048] of char;
begin
 if Assigned(Plugin) then
   with Plugin do
     with Settings do
      begin
       Filename:=ConfigReadString(Section, optFilename);
       if Filename='' then
        begin
         if SHGetSpecialFolderPath(0, Path, CSIDL_PERSONAL, False) then
           Filename:=IncludeTrailingPathDelimiter(String(Path))+sFilename;
        end;
       Template:=ConfigReadString(Section, optTemplate);
       if Template='' then
         Template:='%R - %T';
       //Lang:=ConfigReadString(Section, optLanguage);
       Count:=ConfigReadInteger(Section, optCount);
       if Count<1 then
         Count:=1;
       if Count>CountMax then
         Count:=CountMax;
       Bottom:=ConfigReadBoolean(Section, optBottom);
       UTF:=ConfigReadBoolean(Section, optUTF);
      end;
end;

procedure SaveSettings(const Plugin: TAIMPAddonsCustomPlugin; const Section: String; const Settings: TSettings);
begin
 if Assigned(Plugin) then
   with Plugin do
     with Settings do
      begin
       ConfigWriteString(Section, optFilename, Filename);
       ConfigWriteString(Section, optTemplate, Template);
       //ConfigWriteString(Section, optLanguage, Lang);
       ConfigWriteInteger(Section, optCount, Count);
       ConfigWriteBoolean(Section, optBottom, Bottom);
       ConfigWriteBoolean(Section, optUTF, UTF);
      end;
end;

procedure SettingsChanged(const Settings: TSettings);
begin
 with Settings do
  begin
   //UseLanguage(Lang);
  end;
 if Assigned(OnSettingsChange) then
   OnSettingsChange;
end;

end.
